fix config reading in tests
[git/dscho.git] / git-merge-one-file.sh
blob9ee3f804520eadb322de3d0ea70a2bf9f092b089
1 #!/bin/sh
3 # Copyright (c) Linus Torvalds, 2005
5 # This is the git per-file merge script, called with
7 # $1 - original file SHA1 (or empty)
8 # $2 - file in branch1 SHA1 (or empty)
9 # $3 - file in branch2 SHA1 (or empty)
10 # $4 - pathname in repository
11 # $5 - original file mode (or empty)
12 # $6 - file in branch1 mode (or empty)
13 # $7 - file in branch2 mode (or empty)
15 # Handle some trivial cases.. The _really_ trivial cases have
16 # been handled already by git read-tree, but that one doesn't
17 # do any merges that might change the tree layout.
19 case "${1:-.}${2:-.}${3:-.}" in
21 # Deleted in both or deleted in one and unchanged in the other
23 "$1.." | "$1.$1" | "$1$1.")
24 if [ "$2" ]; then
25 echo "Removing $4"
26 else
27 # read-tree checked that index matches HEAD already,
28 # so we know we do not have this path tracked.
29 # there may be an unrelated working tree file here,
30 # which we should just leave unmolested. Make sure
31 # we do not have it in the index, though.
32 exec git update-index --remove -- "$4"
34 if test -f "$4"; then
35 rm -f -- "$4" &&
36 rmdir -p "$(expr "z$4" : 'z\(.*\)/')" 2>/dev/null || :
37 fi &&
38 exec git update-index --remove -- "$4"
42 # Added in one.
44 ".$2.")
45 # the other side did not add and we added so there is nothing
46 # to be done, except making the path merged.
47 exec git update-index --add --cacheinfo "$6" "$2" "$4"
49 "..$3")
50 echo "Adding $4"
51 test -f "$4" || {
52 echo "ERROR: untracked $4 is overwritten by the merge."
53 exit 1
55 git update-index --add --cacheinfo "$7" "$3" "$4" &&
56 exec git checkout-index -u -f -- "$4"
60 # Added in both, identically (check for same permissions).
62 ".$3$2")
63 if [ "$6" != "$7" ]; then
64 echo "ERROR: File $4 added identically in both branches,"
65 echo "ERROR: but permissions conflict $6->$7."
66 exit 1
68 echo "Adding $4"
69 git update-index --add --cacheinfo "$6" "$2" "$4" &&
70 exec git checkout-index -u -f -- "$4"
74 # Modified in both, but differently.
76 "$1$2$3" | ".$2$3")
78 case ",$6,$7," in
79 *,120000,*)
80 echo "ERROR: $4: Not merging symbolic link changes."
81 exit 1
83 *,160000,*)
84 echo "ERROR: $4: Not merging conflicting submodule changes."
85 exit 1
87 esac
89 src2=`git-unpack-file $3`
90 case "$1" in
91 '')
92 echo "Added $4 in both, but differently."
93 # This extracts OUR file in $orig, and uses git apply to
94 # remove lines that are unique to ours.
95 orig=`git-unpack-file $2`
96 sz0=`wc -c <"$orig"`
97 diff -u -La/$orig -Lb/$orig $orig $src2 | git apply --no-add
98 sz1=`wc -c <"$orig"`
100 # If we do not have enough common material, it is not
101 # worth trying two-file merge using common subsections.
102 expr "$sz0" \< "$sz1" \* 2 >/dev/null || : >$orig
105 echo "Auto-merging $4"
106 orig=`git-unpack-file $1`
108 esac
110 # Be careful for funny filename such as "-L" in "$4", which
111 # would confuse "merge" greatly.
112 src1=`git-unpack-file $2`
113 git merge-file "$src1" "$orig" "$src2"
114 ret=$?
116 # Create the working tree file, using "our tree" version from the
117 # index, and then store the result of the merge.
118 git checkout-index -f --stage=2 -- "$4" && cat "$src1" >"$4"
119 rm -f -- "$orig" "$src1" "$src2"
121 if [ "$6" != "$7" ]; then
122 echo "ERROR: Permissions conflict: $5->$6,$7."
123 ret=1
125 if [ "$1" = '' ]; then
126 ret=1
129 if [ $ret -ne 0 ]; then
130 echo "ERROR: Merge conflict in $4"
131 exit 1
133 exec git update-index -- "$4"
137 echo "ERROR: $4: Not handling case $1 -> $2 -> $3"
139 esac
140 exit 1